;Przykładowy program POOL, możesz go używać,
;modyfikować i rozpowszechniać na licencji GPL.
;Autorzy: R&D Independent Team
;Źródło: www.pool-rnd.com

include "linked_node.l

to node
  use linked_node

  to initialize :r :x :y :px :py
    if :x > 1 [push :links (:a,(:x - 1),:y)]
    if :y > 1 [push :links (:a,:x,(:y - 1))]
    if :x < :n [push :links (:a,(:x + 1),:y)]
    if :y < :n [push :links (:a,:x,(:y + 1))]

    if (or :y = 1 :y = :n :x = 1 :x = :n) [
      eventdisable "onsignalforces
      eventdisable "onsignalstep
      eventdisable "onturtleclicked
      eventdisable "onmouseup
      eventdisable "onmousemove
      "fixed := true
    ]

    ;wywołaj zawsze na koniec inicjalizacji:
    initialized :r :px :py
  end

  to on_step_action
    settc 100 * :v
  end

  settc "green

  signal "ready
end

window
setturtleimg "blue_light
setpalette "blue2red
setbg "black

shared [a n go]
"go := false
"n := 25

"r0 := 5
"size := 20
"x0 := -:size * :n / 2
"y0 := :size * :n / 2

; --- 1. --- utwórz węzły
"a := newarray :n     ;kwadratowa macierz n x n węzłów
for [x 1 :n] [
  let "ax newarray :n ;kolumna n węzłów
  for [y 1 :n] [:ax,:y := (newt $node)]
  :a,:x := :ax
]
(waitsignal "ready children)

; --- 2. --- zainicjalizuj węzły
for [x 1 :n] [
  let "ax :a,:x
  for [y 1 :n] [
    let "px :x0 + :size * (:x - 1)
    let "py :y0 - :size * (:y - 1)
    (initialize :r0 :x :y :px :py) @ :ax,:y
  ]
]

"switch := button "Start {20 60 70 24}
setonclick :switch [
  "go := not :go
  ifelse :go
  [
    settext :switch "Stop
    "clock := timer [
      signalw "forces
      (signalw "step :dt)
      signal "loss
    ] 20
  ] [
    settext :switch "Start
    stoptimer :clock
  ]
]

"fs := (slider "Zasięg {20 10} {1 30 1} :r0)
setonchange :fs [(setr :new) @ children]

"painter := timer [refresh] 50

refresh
